--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   13:01:19 07/07/2010
-- Design Name:   
-- Module Name:   /home/rudenduden/workspace_vhdl/oscione3/i2c_slave_tb.vhd
-- Project Name:  oscione3
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: i2c_slave
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
--USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY i2c_slave_tb IS
END i2c_slave_tb;
 
ARCHITECTURE behavior OF i2c_slave_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT i2c_slave
    PORT(
         pSCL : IN  std_logic;
         pSDA : INOUT  std_logic;
         clk : IN  std_logic;
         reset : IN  std_logic;
         newDATA : OUT  std_logic;
         DATA : OUT  std_logic_vector(7 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal pSCL : std_logic := '0';
   signal clk : std_logic := '0';
   signal reset : std_logic := '0';

	--BiDirs
   signal pSDA : std_logic;

 	--Outputs
   signal newDATA : std_logic;
   signal DATA : std_logic_vector(7 downto 0);

   -- Clock period definitions
   constant clk_period : time := 20 ns;
	constant scl_period : time := 20 us;
	signal run : boolean := true;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: i2c_slave PORT MAP (
          pSCL => pSCL,
          pSDA => pSDA,
          clk => clk,
          reset => reset,
          newDATA => newDATA,
          DATA => DATA
        );

   -- Clock process definitions
   clk_process :process
   begin
	while run loop
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
	end loop;
	wait;
   end process;
	
	-- SCL process definitions
   scl_process :process
   begin
	pSCL <= '1';
	wait for 5*scl_period;
	while run loop
		pSCL <= '0';
		wait for scl_period/2;
		pSCL <= '1';
		wait for scl_period/2;
	end loop;
	wait;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin
		reset <= '0';
      -- hold reset state for 100ms.
      wait for 30 ns;
		reset <= '1';
		pSDA <= '1';
		
      wait for scl_period*4;
		wait for scl_period/2;
		wait for scl_period/4;
		pSDA <= '0';

		wait for scl_period/2;
		wait for scl_period*7;
		wait for scl_period/2;
		
		pSDA <= 'Z';
		
		
		wait for scl_period;
		wait for scl_period/2;
		pSDA <= '1';
		wait for scl_period;
		pSDA <= '0';
		wait for scl_period*6;
		wait for scl_period/2;
		pSDA <= 'Z';
		
		wait for scl_period;
		wait for scl_period/2;
		
		pSDA <= '1';
		
		wait for scl_period*7;
		wait for scl_period/2;
		
		pSDA <= 'Z';
		wait for scl_period;
		wait for scl_period/2;
		
		pSDA <= '0';
		wait for scl_period/2;
		pSDA <= '1';
		wait for scl_period*3;

      -- end stimulus here 
		run <= false;
      wait;
   end process;

END;
